# $Id: access.py 3685 2010-06-02 15:37:13Z wsl $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-9.1.0/src/access.py $

from merescocore.framework import Observable
import re

class AccessException(Exception):
	pass

class RecordAccess(Observable):
	def __init__(self, infra):
		pat = infra.configRoot.get('RestrictedRecords', section = 'authorization')
		self.re = re.compile(pat)
		Observable.__init__(self)

	def checkRecordAccess(self, recordId, req):
		if self.re.match(recordId) and 'uid' not in req:
			raise AccessException(recordId)
		return None
