from merescocore.framework import Observable

from lxml.etree import parse, XSLT, _ElementTree, tostring

class Metadata2Mods(Observable):

    def __init__(self, xslFileList, nsMap):
        Observable.__init__(self)
        self._nsMap = nsMap
        for s in xslFileList:
            if   "picaplus2mods" in s: self._picaplusXslt = XSLT(parse(open(s)))
            elif "metadata2mods" in s: self._metadataXslt = XSLT(parse(open(s)))

    def _convert(self, xmlSource):
        mods = xmlSource.xpath("//mods:mods", namespaces=self._nsMap)
        if mods:
            mods = self._metadataXslt(xmlSource).getroot().getroottree()
        else:
            mods = self._picaplusXslt(xmlSource)
            # modsCollection uitfilteren. Potentieel namespace probleem
            # we gaan ervan uit dat bij de verdere verwerking niet meer gekeken wordt naar de namespace.
            mods = mods.xpath("//mods:mods", namespaces=self._nsMap)[0]
        return mods

    def addDocumentPart(self, identifier=None, name=None, lxmlNode=None):
        return self.add(identifier=identifier, name=name, lxmlNode=lxmlNode)

    def add(self, identifier=None, name=None, lxmlNode=None):
        """should be obsoleted in favor of addDocumentPart"""
        metadata = lxmlNode.xpath("/oai:metadata", namespaces=self._nsMap)
        if metadata: return self.all.addXml(self._convert(lxmlNode))
